' OxygenTestFBLD.bas
' Oxygen Assembler 'Asmosphere' project
' Charles E V Pegge
' 26 April 2008
     const qu as string=chr$(34)
     dim shared pl as any ptr 
     pl = dylibload ("liboxygen.so")
     if pl=0 then print "Library not located":end
     'print pl
     dim shared o2_asm       as FUNCTION (byval as zstring ptr) AS long ' assemble
     dim shared o2_link      as FUNCTION (byval as zstring ptr) AS long ' o2 link **
     dim shared o2_view      as FUNCTION (byval as zstring ptr) AS long ' o2 coding
     dim shared o2_asm_file  as FUNCTION (byval as zstring ptr) AS long ' assemble from file
     dim shared o2_view_file as FUNCTION (byval as zstring ptr) AS long ' o2 coding from file
     dim shared o2_error     as FUNCTION ()                     AS long ' error message if any
     dim shared o2_len       as FUNCTION ()                     AS long ' length of returned string
     dim shared o2_buf       as FUNCTION (byval as long)        AS long ' buffer selector 0..511 (returns pointer)

     o2_link      = dylibsymbol(pl,"o2_link")
     o2_asm       = dylibsymbol(pl,"o2_asm")
     o2_asm_file  = dylibsymbol(pl,"o2_asm_file")
     o2_view      = dylibsymbol(pl,"o2_view")
     o2_view_file = dylibsymbol(pl,"o2_view_file")
     o2_error     = dylibsymbol(pl,"o2_error")
     o2_len       = dylibsymbol(pl,"o2_len")
     o2_buf       = dylibsymbol(pl,"o2_buf")



     ' ** o2_link is automatically called by o2_asm when the assembly is successful.


function gets(byval p as long) as string
    dim s as string
    dim l as long
    dim q as any ptr
    l=o2_len()
    s=space(l)
    if l=0 then goto xgets
    q=strptr(s)
    asm
        mov ecx,[l]
        mov esi,[p]
        mov edi,[q]
        strpt:
            mov al,[esi]
            mov [edi],al
            inc esi
            inc edi
            dec ecx
        jg strpt 
    end asm
    xgets:
    function=s
end function
  

    dim src AS STRING   ' source
    dim cod AS STRING   ' code
    dim lst AS STRING   ' listing
    dim erm AS STRING   ' error message
    dim p   as any ptr  ' pointer to code string
    dim r   AS LONG     ' result
    dim i   AS LONG     ' input param

    dim cr as string = chr$(13)+chr$(10)
    'testing:
    'asm 
    'mov eax, [o2_len]
    'mov [i],eax
    'end asm
    'i=o2_len()
    'print "ok",i
    'dylibfree pl
    'end
    o2_buf(1)              ' optional buffer number 0..511
    src="inc eax"+cr+"ret"   ' minimal source code
    lst=gets(o2_view(src))   ' view assembled code
    cod=gets(o2_asm(src))    ' compile code string
    erm=gets(o2_error())     ' check for any error
    IF erm="" THEN
        i=41
        p=STRPTR(cod)        ' get pointer to code string
        asm
          mov eax,[i]        ' pass a parameter
          call [p]           ' call the code
          mov [r],eax        ' store the result
        end asm
    END IF

    print "Result: ";r
    print
    print "listing:"
    print lst

while inkey$="":wend
dylibfree pl

end
