
' 08:11 25/Mar/2008
' 08:09 06/April/2008 resolve with complete label name
' 10:13 24/April/2008 support backward references

#include "config.bas"


#ifndef ert
    dim shared as long   ert
    dim shared as string ers
#endif


#ifdef THINBASIC

    #include Once "thinCore.bi"

    function GetvarPtr(VarName as string) as long

    dim as BSTR sBSTR
    dim as long MainType , SubType, IsArray,DataPtr,nElements 
        'checks
        'messagebox 0,varname,"check varname",0
        'pbsd.bstr=SysAllocStringByteLen( strptr(VarName), Len(VarName) )
        'dim as long i,j
        'i=thinBasic_VariableGetInfo (pbsd.bstr, @MainType, @SubType, @IsArray )
        'thinBasic_VariableGetInfoEx (pbsd.bstr, @MainType, @SubType, @IsArray ,@DataPtr,@nElements)
        'if i then
        'j=thinBasic_VariablePtrToDirectPtr(i)
        '    i=thinBasic_DirectPtrToDataPtr(i)
        '    'MessageBox 0,str$(peek(long,i))+"     "+str$(MainType)+"     "+str$(SUbType)+"     "+str$(IsArray),"test",0
        '    if DataPtr then MessageBox 0,VarName+"  "+str$(peek(long,Dataptr))+"     "+str$(i)+"     "+str$(j),"vars",0
        'end if

        sBSTR=SysAllocStringByteLen( strptr(VarName), Len(VarName) )
        thinBasic_VariableGetInfoEx (sBSTR, @MainType, @SubType, @IsArray ,@DataPtr,@nElements)
        SysFreeString sBSTR
        function=DataPtr

    end function

#endif



#ifdef STANDALONE

    function GetvarPtr(VarName as string) as long
    function=0
    end function

#endif

#ifdef RDOLLARS

    function GetvarPtr(VarName as string) as long
    function=0
    end function

#endif


function ascl(s as string,i as long) as long
    dim a as long
    a=asc(s,i)
    #ifdef CASE_INSENSITIVE
        if(a>64)and(a<91) then a+=32
    #endif
    function=a
end function

function HexLink(byref s as string, byref i as long ) as string

' a      ascii byte
' b      general purpose
' i      source string position
' j      code position
' k      general purpose
' l      length of source
' m      general purpose
' n      general purpose
' s      source  string
' t      code string
' v      general purpose
' nb()   starting position of current block
' xi()   attributes of foward reference
' bkd()  nesting depth of label
' bkp()  position of label
' bkw()  label name
' bke    label list boundary
' neb    current nesting depth
' wd     word
' ke     keyword

' ert    global error type
' ers    global error message string

static as long nb(127),xi(511,3),bkd(511),bkp(511)
static as string xn(511),bkw(511)
dim    as long neb=0, xib=0, bke=0
dim    as long j=1, k=0, m=0, n=0, v=0,a=0, b=0, l=len(s)
dim    as string wd,ke


ert=0
if i<1 then i=1
dim as string t=string$(l-i+200,chr$(0)),tb=""
do ' main loop
    do ' skip space for next word 
        if (i>l)or(asc(s,i)>32) then exit do
        i+=1
    loop
    if i>l then exit do 
    do ' case interpret word
        a=ascl(s,i)
        if a=35 then ' # variable address
            m=i+1
            do
             i+=1
             if i>l then exit do
             a=asc(s,i): if a<48 then exit do
            loop
            wd=mid$(s,m,i-m): m=0
            if len(wd) then m=GetVarPtr(wd)
            if m=0 then ers="Can't find #symbol: "+wd:ert=5: goto exitf
            mid$(t,j)=mkl$(m):j+=4 ' patch in var addr
            exit do
        end if
        if a=39 then ' ' comment
            do ' advance to end of line
                i+=1: if (i>l)or(asc(s,i)<=13) then exit do
            loop
            exit do ' next word on next line
        end if
        ' reserve a place in the jump table:
        if a=58 then ' :
            i+=2: tb=tb+chr$(&he9)+mkl$(j-1)+chr$(&h90)+chr$(&h90)+chr$(&h90): k+=1: exit do
        end if
        if a=34 then ' " double quote
            m=i+1
            do
                i+=1
                if i>l then exit do
                if asc(s,i)=34 then exit do
            loop
            mid$(t,j)=mid$(s,m,i-m): j+=i-m: i+=1
            exit do ' cases
        end if
        if a=36 then ' $ reserve space 
            m=0
            if asc(s,i+1)=36 then m=4: i+=1 ' $$ align
            v=val("&h"+mid$(s,i+1,4))
            t= left$(t,j-1) + string$(v,chr$(0)) + mid$(t,j)
            j+=v
            v=(j-1) and &hfffffffc:v+=1
            if v<j then j=v+4
            exit do
        end if
        if a=&h5b then  ' [ ] nestable superquote ascii char strings
            m=0: a=i
            do 
                i+=1
                if i>l then exit do
                if asc(s,i)=&h5b then m+=1 ' [
                if asc(s,i)=&h5d then m-=1: if m<0 then exit do ' ]
            loop
            a+=1
            mid$(t,j)=mid$(s,a,i-a): j+=i-a: i+=1: exit do
        end if
        ' block programming
        if a=40 then neb+=1:nb(neb)=j:i+=1:exit do '(
        if a=41 then
            ' remove back labels which are now out of scope
            b=-1
            do
                b+=1:if b>=bke then exit do
                if bkd(b)>=neb then
                    v=b
                    do
                        v+=1:if v>=bke then exit do
                        bkw(v-1)=bkw(v)
                        bkd(v-1)=bkd(v)
                        bkd(v-1)=bkp(v)
                    loop
                    bke-=1
                    b-=1
                end if
            loop
        end if
        if (a=41)or(a=46) then ') . fwd refs only
            if a=46 then 
                i+=1 ' dot label
                v=ascl(s,i)*256:a=ascl(s,i+1)
                if a<48 then a=32
                v+=a ' 2 significant letters
                'capture full name
                m=i
                do
                    a=asc(s,i)
                    if a<33 then exit do
                    i+=1
                loop
                ke=lcase$(mid$(s,m,i-m))
                bkw(bke)=ke:bkp(bke)=j:bkd(bke)=neb:bke+=1
                a=v
            end if
            if xib>0 then
                v=xib-1
                do 'scan exits table
                    if v<0 then exit do
                    if (xi(v,1)=a)and(xi(v,2)>=neb)and(xn(v)=ke) then
                        m=xi(v,0)
                        do
                            if m<0 then mid$(t,-m)=mkl$(j+m-4): exit do
                            n=(j-m-1)
                            if (n<0)or(n>127) then ers="Jump out of range (-128..+127)":ert=2: goto exitf ' short fwd jump out of range
                            mid$(t,m)=chr$(n)
                            exit do ' cases
                        loop
                        xi(v,1)=0: xi(v,2)=0: xn(v)="" 
                    end if
                    v-=1
                loop
                ' consolidate list
                v=0:m=0
                do
                    do
                        if xi(v,1)<>0 then ' skip valid entries
                            v+=1:if m<=v then m=v
                            exit do
                        end if
                        if xi(m,1)=0 then exit do ' omit used entries
                        ' otherwise relocate unresolved entries
                        xi(v,0)=xi(m,0):xi(v,1)=xi(m,1):xi(v,2)=xi(m,2)
                        xi(m,0)=0: xi(m,1)=0:xi(m,2)=0:v+=1
                        exit do 'cases
                    loop
                    m+=1:if m>xib then exit do
                loop
                xib=v
            end if
            if a=&h29 then neb-=1 ' )
            if neb<0 then ers="Too many right brackets":ert=4: goto exitf
            i+=1:exit do
        end if
        m=ascl(s,i+1)
        if a=&h67 then
             i+=1:if m=&h6c then i+=1
             ' optional gap for name
             do
                 a=asc(s,i): if (a<1)or(a>32) then exit do
                 i+=1
             loop
             v=ascl(s,i)*256:a=ascl(s,i+1)
             if a<48 then a=32
             v+=a ' 2 significant letters
             k=i
             do
                 a=asc(s,i)
                 if a<33 then exit do
                 i+=1
             loop
             ke=lcase$(mid$(s,k,i-k))
             xn(xib)=ke
             ' search backward
             b=bke
             do
                 b-=1:if b<0 then exit do
                 if (ke=bkw(b))and(bkd(b)<=neb) then
                 n=bkp(b)-j
                 if m=&h6c then mid$(t,j)=mkl$(n-4):j+=4:goto nexw
                      n-=1
                      if (n<-128)or(n>127) then ers="Jump out of range (-128..+127)":ert=2: goto exitf ' short jump out of range
                      mid$(t,j)=chr$(n and 255):j+=1:goto nexw
                 end if
             loop
             if m=&h6c then xi(xib,0)=-j:xi(xib,1)=v:xi(xib,2)=neb:xib+=1:j+=4: exit do' g  ' long
             xi(xib,0)=j:xi(xib,1)=v:xi(xib,2)=neb:xib+=1:j+=1: exit do' g 'short
        end if
        if a=&h78 then
            if m=&h6c then i+=1: xi(xib,0)=-j:xi(xib,1)=&h29:xi(xib,2)=neb:xib+=1:j+=4: exit do' x exit
            xi(xib,0)=j:xi(xib,1)=&h29:xi(xib,2)=neb:xib+=1:j+=1: exit do' x exit
        end if
        if a=&h72 then ' r repeat 
            if m=&h6c then i+=1:v=nb(neb)-j-4: mid$(t,j)=mkl$(v):j+=4:exit do ' r repeat
            v=nb(neb)-j-1: if v<-128 then ers="'Repeat' out of range (-128..+127":ert=3: goto exitf ' short loop out of range
            mid$(t,j)=chr$(v and &hff):j+=1:exit do
        end if
        '
        ' otherwise assume a decimal octal or hex code
        if a=&h68 then 'h for hex
            i+=2
            if m=&h77 then mid$(t,j)=mkshort$(val("&h"+mid$(s,i,4))):j+=2: exit do ' w
            if m=&h6c then mid$(t,j)=mkl$(val("&h"+mid$(s,i,8))):    j+=4: exit do ' l
            i-=1: mid$(t,j)=chr$(val("&h"+mid$(s,i,2))):             j+=1: exit do ' default hex byte
        end if
        if a=&h6e then 'n for decimal
            i+=2
            if m=&h77 then mid$(t,j)=mkshort$(val(mid$(s,i,16))):  j+=2: exit do ' w
            if m=&h6c then mid$(t,j)=mkl$(val(mid$(s,i,16))):      j+=4: exit do ' l
            if m=&h71 then mid$(t,j)=mklongint(val(mid$(s,i,26))): j+=8: exit do ' q
            if m=&h73 then mid$(t,j)=mks$(val(mid$(s,i,16))):      j+=4: exit do ' s
            if m=&h64 then mid$(t,j)=mkd$(val(mid$(s,i,24))):      j+=8: exit do ' d
            if m=&h62 then mid$(t,j)=chr$(val(mid$(s,i,16))):      j+=1: exit do ' b 
            i-=1: mid$(t,j)=chr$(val(mid$(s,i,16))):               j+=1: exit do ' default decimal byte
        end if
        if i+2<l then 'octal byte
            if asc(s,i+2)>47 then mid$(t,j)=chr$(val("&o"+mid$(s,i,3))): j+=1: exit do
        end if
        mid$(t,j)=chr$(val("&h"+mid$(s,i,2))): j+=1:exit do ' default hexadecimal byte
        exit do ' always drop out
    loop ' end cases
nexw:    '
    do ' find delimiting char before next word 
        if (i>l)or(asc(s,i)<=32) then exit do
        i+=1
    loop
    a=len(t): if j>a-200 then t+=string$(1000,chr$(0))
    if xib>511 then ert=15:goto exitf ' ref limit
loop
'
' calculate rel jumps for table
i=0
do
    if i>=k then exit do
    m=i*8: mid$(tb,m+2) = mkl$( cvl(mid$(tb,m+2,4))+len(tb)-m-5 ) ' relative jump
    i+=1
loop
exitf:
    if j<2 then ers="No code to generate":ert=10
    if (ert=0)and(xib>0) then
        ers="Unresolved refs to (dot) .labels:"
        v=xib:a=0
        ers+=chr$(13)+chr$(10)+chr$(10)+"name"+chr$(9)+"nesting level"
        do
            v-=1:if v<0 then exit do
            a=xi(v,1)
            ers+=chr$(13)+chr$(10)+xn(v)+".."+chr$(9)+str$(xi(v,2))
        loop
        ert=1000000+xi(xib-1,1) 'unresolved refs
    end if
    if ert>0 then function=chr$(&hc3): exit function
    function=tb+left$(t,j-1)
end function


