
'------------------------------------------------------------------------------
' O2 OXYGENz dll version
'------------------------------------------------------------------------------

' 11:30 26/April/2008

    ' compiled with Freebasic .18
    ' fbc -dylib oxygen.bas

    #include "O2fun.bas"
    #include "O2asm.bas"


   dim shared as string dbuf(511)
   dim shared as string obuf
   dim shared as long   lbuf
   dim shared as long   pbuf


#ifdef OS_MS
 Extern "Windows-MS"  
#else
 extern "C"
#endif


    Function o2_len() as long export
    Function = lbuf
    End Function


    Function o2_buf(byval p as long) as long export
    if (p>511)or(p<0) then
       p=0: ers=" Buffer number out of range (0..511): "+str$(p): p=0
    end if
    pbuf=p
    Function = cast(long,strptr(dbuf(p)))
    End Function


    Function o2_link(byval p as zstring ptr) as long export
    dim src as string
    dim i   as long
    i=1
    src=*p
    dbuf(pbuf)=hexlink( src,i )
    lbuf=len(dbuf(pbuf))
    Function = cast(long,strptr(dbuf(pbuf)))
    End Function


    Function o2_asm(byval p as zstring ptr) as long export
    dim as string  src,sco
    dim as long    i
    i=1
    src=*p
    sco= Assemble( src,i )
    dbuf(pbuf)=chr$(&hc3) 'ret default
    if ert=0 then
        i=1
        dbuf(pbuf)=HexLink( sco,i )
    end if
    lbuf=len(dbuf(pbuf))
    Function = cast(long,strptr(dbuf(pbuf)))
    End Function

    Function o2_asm_file(byval p as zstring ptr) as long export
    dim as string  src,sco
    dim as long i,fi
    i=1: fi=freefile
    src=*p
    open src for binary access read as fi
    src=space$(lof(fi))
    get$ #fi,,src
    close fi
    sco= Assemble( src+"",i )
    dbuf(pbuf)=chr$(&hc3) 'ret default
    if ert=0 then
        i=1
        dbuf(pbuf)=HexLink( sco,i )
    end if
    lbuf=len(dbuf(pbuf))
    Function = cast(long,strptr(dbuf(pbuf)))
    End Function


    Function o2_view(byval p as zstring ptr) as long export
    dim as string  src,sco
    dim as long    i
    i=1
    src=*p
    vew=2
    obuf=Assemble( src,i )
    vew=0
    lbuf=len(obuf)
    Function = cast(long,strptr(obuf))
    End Function



    Function o2_view_file(byval p as zstring ptr) as long export
    dim as string  src,sco
    dim as long i,fi
    i=1: fi=freefile
    src=*p
    open src for binary access read as fi
    src=space$(lof(fi))
    get$ #fi,,src
    close fi
    vew=2
    obuf=Assemble( src,i )
    vew=0
    lbuf=len(obuf)
    Function = cast(long,strptr(obuf))
    End Function

    Function o2_error() as long export
    lbuf=len(ers)
    Function = cast(long,strptr(ers))
    End Function

End Extern
